Occupancy-state reductions make dynamic programming possible for zero-sum partially observable stochastic games (zs-POSGs). Existing point-based solvers usually optimise a central value function. This restores Bellman recursion, but it requires point-based updates over high-dimensional occupancy spaces. We introduce an approximate policy-iteration algorithm for finite-horizon zs-POSGs. The method maintains one policy per player and updates both jointly along occupancy trajectories induced by conservative policy updates. Instead of approximating a full central value function, each update uses a single supporting hyperplane induced by the current joint policy. The algorithm alternates local policy improvements, conservative updates, and persistent exploration. Computation is therefore concentrated on occupancy regions where the current joint policy is exploitable. On finite-horizon zero-sum POSG benchmarks, the method is competitive at small horizons and often improves the runtime-exploitability trade-off at larger horizons compared with PBVI, HSVI, and CFR+.
Figures & tables
Figure 1: The optimal value function of the game Mi is convex in the belief space. While value-iteration methods such as PBVI sample this space and operate on a set of vectors to represent vi,t , our method works with a single vector vi,tπt:Ti at a time, reducing the complexity of the associated algorithms.
Figure 2: Evolution of value and exploitability across different games under a fixed horizon ℓ=5 . The results compare three methods: CFR+ , PBVI , and CPI , highlighting their respective performance profiles in terms of convergence behaviour and solution quality across the considered benchmarks.
CPI (Ours)
PBVI
HSVI
CFR+
Problem
T
t
val.
ϵ
t
val.
ϵ
t
val.
ϵ
t
val.
ϵ
2
0.3
0.078
0.2
0.078
0.4
0.078
0.3
0.078
3
11
0.097
24
0.096
70
0.097
12
0.095
4
23
0.11
65
0.11
0.01
oot
oot
oot
49
0.11
0.01
5
29
0.12
31
0.12
oot
oot
oot
82
0.12
0.01
7
97
0.14
0.01
190
0.14
0.005
oot
oot
oot
292
0.14
0.02
Table 1: Snapshot of the empirical results, including the computational cost of exploitability evaluation. For each game, horizon and algorithm, we report time, value and exploitability ϵ associated with the computed ϵ -Nash equilibrium. OOT occurs when the target exploitability threshold cannot be reached within the prescribed time limit, while oom means that the algorithms ran out of memory. magenta = lowest exploitability/value per benchmark
Appendix figures & tables6 assets
Supplementary material from the paper’s appendix.
Appendix
Update step
# variables
# constraints
Ours: LP
∣Ht1∣∣At1∣+∣Ht2∣∣At2∣∣Zt2∣+∣Ht2∣
O(∣Ht2∣∣At2∣∣Zt2∣∣Λ∣)
( Delage et al., 2023 )
(rule variables + epigraph)
Exponential: O(∣At2∣∣Ht2∣)
( Escudie et al., 2025 )
∣Ht1∣∣At1∣∣Γ1∣+∣Ht2∣∣At2∣∣Zt2∣+∣Ht2∣
O(∣Γ1∣⋅∣Γ2∗∣⋅∣Ht2∣⋅∣At2∣⋅∣Zt2∣)
Appendix
Table 2: LP complexity comparison (input-size view). The OMG greedy-update LP has constraints indexed by opponent decision rules, yielding an exponential dependence on ∣Ht2∣ ( Delage et al., 2023 ) . Both the cached-envelope greedy LP ( Escudie et al., 2025 ) and our backup scale polynomially in the same explicit representation objects, but expose different optimization structures. In our formulation, both the number of variables and constraints are reduced by a factor of ∣Γ1∣ . Here, ∣Γ1∣ denotes the number of piecewise-linear concave functions maintained, while ∣Λ∣ is the number of piecewise-linear vectors associated with each element of Γ1 .
Figure 3: Example of a situation at T=2 . The background represents the gradient of the dual gap at t=0 . The black arrows represent updates of the policy where only π0i is changing. At t=0 , since i has an optimal view of the pessimistic value function, the move strictly improves the global dual gap. The dashed arrows represent updates at t=1 ; since the update is also influenced by −i past, nothing guarantees that the update will follow the global dual gap d0 gradient direction. Here, we present an extreme case where the update at t=1 almost cancels the one at t=0 . On the left , we do not adapt the step sizes, on the right , we apply the proof such that destructive updates are avoided and we are sure the updates go to the right direction.
Figure 4: TG→G′ denotes the reduction from game G to game G′ . The reduction TPOSG→EFG is almost transparent: it simply reformulates the POSG as an extensive-form game (EFG). However, unlike TPOSG→SG , this reduction does not induce an equilibrium concept that can be characterized inductively in the reduced game. The composition TPOSG→EFG∘TEFG→OEFG corresponds to the focal-planner reduction introduced in Escudie et al. (2025) .
Name in EFG
Symbol
Name in POSG
Symbol
History
h
State and Joint history
(st,ht)
i’s information set
I
i’s private history
hi
Strategy profile
σ
Joint policy
π
i’s private strategy
σi
i’s private policy
πi
Players’ contribution except i
πiσ(I)
Players’ contribution except i
Pr(hi∣π,b0)
Players’ contribution except i
πiσ(h)
Counterfactual state
ci(s,h−i)
Appendix
Table 3: Translation from EFG to POSG. For more information, we refer the reader to ( Kovařík et al., 2022 ) . We connect the history h in EFG to the pair (s,h) in POSG since the reward is not associated to the history but to the state in POSG. The quantity vMπ(s,h) is formally defined in ( Cunha et al., 2023 ) , we refer the reader for more information. It is simply the expected cumulated value a player can get at this pair.
CPI (Ours)
PBVI
HSVI
CFR+
Problem
T
t
val.
ϵ
t
val.
ϵ
t
val.
ϵ
t
val.
ϵ
2
0.3
0.078
0.2
0.078
0.4
0.078
0.3
0.078
3
11
0.097
24
0.096
70
0.097
7
0.095
4
23
0.11
65
0.11
0.01
oot
oot
oot
25
0.11
0.01
5
29
0.12
31
0.12
oot
oot
oot
69
0.12
0.01
7
97
0.14
0.01
190
0.14
0.0
oot
oot
oot
92
0.14
0.02
Appendix
Table 4: Snapshot of empirical results. For each game, horizon and algorithm, we report time, value and exploitability ϵ associated with the computed ϵ -Nash equilibrium. OOT occurs when the target exploitability threshold cannot be reached within the prescribed time limit, while oom means that the algorithms ran out of memory. magenta = lowest exploitability value per benchmark, while ‘ − ’ means the time budget for computing the exploitability has been exceeded.
CPI (Ours)
PBVI
HSVI
CFR+
Problem
T
t
val.
ϵ
t
v
ϵ
t
val.
ϵ
t
val.
ϵ
2
0.3
0.078
0.2
0.077
0.3
0.078
0.3
0.078
0.003
3
5
0.097
19
0.097
70
0.097
12
0.096
0.002
4
38
0.11
0.001
50
0.1
0.001
oot
oot
oot
73
0.11
0.003
Mabc
5
2176
0.12
0.01
1365
0.12
0.013
oot
oot
oot
1614
0.12
0.005
2
0.01
0.4
0.13
0.38
0.1
0.4
0.01
0.4
Appendix
Table 5: A snapshot of empirical results with no pruning mechanism applied (see Escudie et al. (2025) , Dibangoye et al. (2016b) ). For each game, horizon and algorithm, we report time, value and exploitability ϵ associated with the computed ϵ -Nash equilibrium. OOT occurs when the target exploitability threshold cannot be reached within the prescribed time limit, while oom means that the algorithms ran out of memory. magenta = lowest exploitability value per benchmark, while ‘ − ’ means the time budget for computing the exploitability has been exceeded.
The Policy-Space Response Oracles (PSRO) framework scales equilibrium computation to large zero-sum games by iteratively expanding a restricted strategy set using deep reinforcement learning (DRL). A central challenge is to construct, under limited computational budgets, a small strategy population whose induced game well approximates the full game. Existing PSRO variants typically expand the population using best responses to meta-strategies computed from restricted-game payoffs, which can lead to inefficient expansions that provide limited global improvement. We propose to guide population expansion by directly evaluating the post-expansion population quality. Specifically, we adopt Population Exploitability (PE) to measure how well a restricted strategy set represents the full game, and introduce a two-phase exploration--selection framework that explicitly minimizes PE during expansion. We instantiate this framework as Global PSRO, a practical DRL-based algorithm that efficiently generates candidate responses and estimates PE via parameter-sharing conditional neural networks. Experiments across multiple two-player zero-sum games show that Global PSRO achieves lower exploitability and approximates Nash equilibria with significantly fewer policy iterations than prior PSRO methods.
Junyu Zhang, Feihong Yang, Jian Wang +2
Department of Electronic Engineering, Tsinghua University, Beijing, China · Qiyuan Lab, Beijing, China
Zero-sum Markov games arise in a wide variety of sequential decision-making problems such as adversarial learning and planning against modeled uncertainties. However, prior work on finite-sample guarantees on the learned state-action value function (Q-function) for zero-sum Markov games is largely restricted to finite-action settings, or to continuous-action games in which agents have linear dynamics and quadratic rewards (i.e. linear-quadratic, or LQ, games). A central challenge in extending such guarantees to more general continuous-action zero-sum Markov games is that the associated Bellman operator involves a minimax problem that need not admit a tractable saddle-point solution. To this end, we first introduce a class of neural network function approximators for the Q-function that is convex-concave in the players' actions, which guarantees that this minimax problem admits a pure-strategy saddle point. We then study an online variant of fitted Q-iteration employing this function class and establish, to the best of our knowledge, the first finite-sample guarantees for non-LQ zero-sum Markov games with continuous states and actions. Our code can be found at https://github.com/CLeARoboticsLab/QCanPlayThatGame.
Kushagra Gupta, Jingqi Li, Cade Armstrong +4
The University of Texas at Austin · The University of California, Berkeley · Massachusetts Institute of Technology (MIT) Lincoln Labs
Optimally solving decentralized decision-making problems modeled as Dec-POMDPs is known to be NEXP-complete. These optimal solutions are policies based on the entire history of observations and actions of an agent. However, some applications may require more compact policies because of limited compute capabilities, which can be modeled by considering a limited number of memory states (or agent states). While such an agent-state based policy class may not contain the optimal solution, it is still of practical interest to find the best agent-state policy within the class. We focus on an iterated best response style algorithm which guarantees monotonic improvements and convergence to a local optimum in polynomial runtime in the Dec-POMDP model size. In order to obtain a better local optimum, we use a modified objective which incentivizes risk-seeking alongside a conservative policy iteration update. Our empirical results show that our approach performs as well as state-of-the-art approaches on several benchmark Dec-POMDPs, achieving near-optimal performance while having polynomial runtime despite the limited memory. We also show that using more agent states (a larger memory) leads to greater performance. Our approach provides a novel way of incorporating memory constraints on the agents in the Dec-POMDP problem.
Amit Sinha, Matthieu Geist, Aditya Mahajan
Department of Electrical and Computer Engineering, McGill University, Montreal, Quebec · Earth Species Project